--------------------------- as86 Macro Library -------------------------------
(c) Franois-Ren "Far" Rideau Dang-Vu Bn 1989,1995
see info file .../doc/info/m4macros.nfo (section * as86.m4::)


Provide({as86},{

------ as86 Assembler syntax ------

changecom({;})
define({comment},{;;$*})
define({Hexnumber},{0x$1})
define({isImm},{ifelse(
regexp({$1},{\`\(#\|-?\(0x[0-9a-fA-F]+\|[0-9]+\)\)\'}),-1,0,1)})
define({isImmByte},
{ifelse(regexp({$1},{^#?[ 	]*-?\(0x[0-9a-fA-F][0-9a-fA-F]?\|[01]?[0-9][0-9]?\|2[0-4][0-9]\|25[0-5]\)$}),-1,0,1)})


------ Architecture-dependent information ------

define({__BYTE_ORDER},1234)dnl (little endian)
define({PAGESIZE},4096)
define({PAGEBITS},12)



------ Assembly control information ------

define({i386usemode},{})
define({i386usemoderegext},{})
define({use16},
    {{use16}
     define({i386usemode},{})
     define({i386usemoderegext},{})})
define({use32},
    {{use32}
     define({i386usemode},{d})
     define({i386usemoderegext},{e})})
define({regext},
    {cat(i386usemoderegext,$@)})
define({isreg},
	{ifelse(regexp(downcase($1),
			{^e?\([a-d][hlx]\|[sd]i\|[sb]p\)$},1),
		1,1,0)})



------ Instruction set enhancement macros ------

define({clr},{ifelse(isreg($1),1,{xor $1,$1},{mov $1,#0})
ifelse({$2},{},,{clr(shift($@))})})
define({setf},{ifelse(isreg($1),1,{or $1,$1},{test $1,#-1})})
define({bswaperx},
  {xchg $1l,$1h
   rol e$1x,16
   xchg $1l,$1h})
define({flushinstr},{local({fi},{jmp fi
fi:})})
define({___die___},{local({diediediedie},
{diediediedie:
hlt
jmp diediediedie})})

define({pushaX},{cat9({pusha},i386usemode)})
define({popaX},{cat9({popa},i386usemode)})
* BEWARE !!!
The instruction following a popa/popad MUST NOT use the base+index register
addressing mode, or else most 386 cpus will trash eax, or even crash if eax
is used in the addressing. That's an intel bug. Avoid it.

define({pushfx},{cat9({pushf},i386usemode)})
define({popfx},{cat9({popf},i386usemode)})


------ push multiple values ------

* {pushm} pushes its multiple operand in reverse order; thus, after
		pushm(a,b,c,d)
 is executed, the structure pushed on the stack is a,b,c,d.
 note that pushing is done in reverse order, in case you use sp-relative
 addressing in the {pushm}.
* {popm} is the converse of {pushm}; thus, after {pushm(a,b,c,d)},
 you restore the state with {popm(a,b,c,d)}; note that popping is done in
 the specified order, so in case you pop the same destination multiple
 times, the last pop gives its value. So for instance {popm(ax,ax)}
 will discard first value and pop ax.

define({_push},
{ifelse(regexp(param,{[af][dX]?$}),0,{{push}param{}__nl__},
	 param,regext(ip),{local({Lbl},{call Lbl __nl__ Lbl:})},
	 {__unseg__({push},{param})
})})
define({pushm},{_pushm(reverse($@))})
define({_pushm},{irp({param},{$@},{_push(param)})})
define({popm},{irp({param},{$@},{_pop(param)})})
define({_pop},
{ifelse(regexp(param,{[af][dX]?$}),0,{{pop}param{}__nl__},
	{param},{regext(ip)},{ret},
	{{pop} param{}__nl__})})})
define({pushing},
   {pushm($1)
    $2
    popm($1)})


define({__unseg__},
   {ifelse(regexp({$2},{\(.*\):\(.*\)},
		  {pushdef({_seg_},{\1})pushdef({_ofs_},{\2})1}),
	   1,
	   {seg _seg_
	    $1 _ofs_ $3 popdef({_seg_})popdef({_ofs_})},
	   {$1 $2 $3})})
define({ppmov},
{dnl Move $2 to $1 by pushing/popping
	pushm($2)
	popm($1)
})
define({ttmov},
{dnl Move $2 to $1 through temporary reg/mem $3
	mov $3,$2
	mov $1,$3
})
define({movzil},
	{clr(e$1x)
	mov $1l,$2})
define({movm},
   {irp({params},{$@},{__Mov__(params)
})})
define({__Mov__},
{ifelse(isreg({$1}),0,{mov $1,$2},
	isImmByte({$2}),0,{mov $1,$2},
	{$2},{0},{sub $1,$1},
	len({$1}),2,{mov $1,$2},
	{$2},{1},{xor $1,$1 __nl__ inc $1},
	{$2},{-1},{xor $1,$1 __nl__ dec $1},
	{ppmov($1,$2)})})

define({SegOfsToLinear},
{dnl dest,destofs,ofs,seg,adjust
	movzx $1,word $4
	movzx e$2,word $3
	ifelse({$5},{},,{AddIm($2,$5)})
	shl $1,#4
	add $1,e$2
	ifelse({$6},{},,{mov $3,$2})
})

dnl
dnl
dnl --- Memory allocation ---
dnl
define({newheap},
	{ifelse($#,1,{define({heap_$1},0)}{define({heapprefix_$1},{})},
		$#,2,{define({heap_$1},{$2})}{define({heapprefix_$1},{})},
		{define({heap_$1},{$3})}{define({heapprefix_$1},{$2+})})})
define({allot},{cat(heapprefix_$1,varadd({heap_$1},$2))})
define({_alignoffset},
	{ifelse($#,0,0,
		$#,1,0,
		$#,2,{eval(($2-1)-(($1+$2-1)%($2)))},
		{eval(($2-1)-(($1-$3+$2-1)%($2)))})})
define({_aligned},{eval(_alignoffset($@)+$1)})
define({alignheap},{ifelse(allot({$1},_alignoffset(heap_$@)))})
define({alallot},
	{ifelse($#,0,,$#,1,,
		$#,2,{alignheap({$1},{$2}){}allot({$1},{$2})},
		{alignheap({$1},{$2}){}allot({$1},{$3})})})
define({_member},{dnl
  forget({_member
	{{$1}} is member type size
	{{$2}} is field name
	{{$3}} is multiplier
	{{$4}} is alignment required
  })dnl
  ifelse({$4},,,
	 {alignheap(StrucName,{$4})})
  ifelse({$2},,,{StrucName{$2} = })dnl
  ifelse({$3},,
	 {allot(StrucName,{$1})},
	 {allot(StrucName,eval({$1}*{$3}))})
})
define({_byte},
	{ifelse($#,0,,$#,1,,
		$#,2,{alignheap({$1},{$2}){}allot({$1},{$2})},
		{alignheap({$1},{$2}){}allot({$1},{$3})})})
dnl
dnl
dnl --- Structures ---
dnl
define({StrucName},{})
define({Struc},
{pushdef({StrucName},StrucName{$1_})dnl
newheap(StrucName)dnl
expand({$2}){}dnl
define({sizeof_$1},allot(StrucName,0))dnl
popdef({StrucName})dnl
})
define({_member_},
  {forget({_member_}
	StrucName {is structure name
	{{$1}} is member type size
	{{$2}} is field name
	{{$3}} is multiplier
	{{$4}} is alignment required
  })dnl
  ifelse({$4},{},{},
	 {alignheap(StrucName,{$4})})dnl
  ifelse({$2},{},{},{StrucName{$2} = })dnl
  ifelse({$3},{},
	 {allot(StrucName,{$1})},
	 {allot(StrucName,eval({$1}*{$3}))})
})
define({_byte__},{_member_(1,$@)})
define({_word__},{_member_(2,$@)})
define({_long__},{_member_(4,$@)})
define({_byte_},{_member_(1,{$1},{$2})})
define({_word_},{_member_(2,{$1},{$2},2)})
define({_long_},{_member_(4,{$1},{$2},4)})
dnl
dnl
dnl --- Useful Constants ---
dnl
define({FLAG_CF},	0x00000001)dnl	Carry
define({FLAG_SET},	0x00000002)dnl	????
define({FLAG_PF},	0x00000004)dnl	Parity
define({FLAG_AF},	0x00000010)dnl	Auxiliary Carry for BCD
define({FLAG_ZF},	0x00000040)dnl	Zero
define({FLAG_SF},	0x00000080)dnl	Sign
define({FLAG_TF},	0x00000100)dnl	Trap
define({FLAG_IF},	0x00000200)dnl	Interrupt 0:Disable 1:Enable
define({FLAG_DF},	0x00000400)dnl	Direction 0:Upward  1:Downward
define({FLAG_OF},	0x00000800)dnl	Overflow
define({FLAG_IOPL},	0x00003000)dnl	IO Priviledge requirement mask
define({FLAG_IOPL1},	0x00001000)dnl	IO Priviledge requirement 1
define({FLAG_IOPL2},	0x00002000)dnl	IO Priviledge requirement 2
define({FLAG_IOPL3},	0x00003000)dnl	IO Priviledge requirement 3
define({FLAG_NT},	0x00004000)dnl	Nested Task
define({FLAG_RF},	0x00010000)dnl	Resume debug
define({FLAG_VM},	0x00020000)dnl	V86 Mode
define({FLAG_AC},	0x00040000)dnl	Alignment Check
define({FLAG_ID},	0x00200000)dnl	CPUID available

define({CR0_PE},	0x00000001)dnl	Protected mode Enable
define({CR0_MP},	0x00000002)dnl	Math copro Present
define({CR0_EM},	0x00000004)dnl	Emulate Math copro
define({CR0_TS},	0x00000008)dnl	Task Switched
define({CR0_ET},	0x00000010)dnl	Extension Type
define({CR0_NE},	0x00000020)dnl	Numeric Error
define({CR0_WP},	0x00010000)dnl	Write Protect
define({CR0_AM},	0x00020000)dnl	Alignment Mask
define({CR0_NW},	0x20000000)dnl	No Write-back
define({CR0_CD},	0x40000000)dnl	Cache Disable
define({CR0_PG},	0x80000000)dnl	Pageing

define({CR3_PWT},	0x00000004)dnl	Page Write Transparency
define({CR3_PCD},	0x00000010)dnl	Page Cache Disable

define({ASCII_defs},{
; ASCII codes
LF	=	0x0A
CR	=	0x0D
Escape	=	0x1B
define({CRLF},{CR,LF})
})
define({Scan_Code_defs},{
; Keyboard scancodes
K_Home	=	0x47
K_Up	=	0x48
K_PgUp	=	0x49
K_Lft	=	0x4B
K_Rgt	=	0x4D
K_EndC	=	0x4F
K_Dn	=	0x50
K_PgDn	=	0x51
K_InsC	=	0x52
K_Del	=	0x53
})dnl
dnl
dnl
dnl ---------------------- Structured programming ---------------------------
dnl
__newstk__({struct})
dnl --- negating code condition
define({ncc},
	{ifelse({$1},{po},{pe},
		{$1},{pe},{po},
		regexp({$1},{^n\(.*\)},{T}),{T},regexp({$1},{^n\(.*\)},{\1}),
		{n}{$1})})
define({jn},
	{{j}ncc($1) shift($@)})

dnl
dnl --- __IF__ ... __THEN__ ... ( __ELSE__ ...) __ENDIF__ ---
dnl
define({IFNUM},0)
define({__EXIT__IF__},{ENDIF})
define({__EXIT__ELSE__},{ENDIF})
define({__EXIT__THEN__},{ENDIF})
define({__IF__},
	{__push__({struct},{@IF}:varincr({IFNUM}):{$1})})
define({__THEN__},
  {ifelse(
    regexp(__pick__({struct}),{@IF:\(.*\):\(.*\)},
		{1{}pushdef({ifnum},{\1})pushdef({cc},{\2})}),
    1,
    {__pop__({struct})
     jn(cc) {ELSE}ifnum
     __push__({struct},{@THEN:}ifnum:)popdef({ifnum})popdef({cc})},
     {errprint({{__THEN__} does not match {__IF__}},
		__pick__({struct}),__nl__)})})
define({__ELSE__},
  {ifelse(
    regexp(__pick__({struct}),{^@THEN:\(.*\):$},{1{}pushdef({ifnum},{\1})}),
    1,
    {__pop__({struct})
     jmp {ENDIF}ifnum
     {ELSE}ifnum:
     __push__({struct},{@ELSE:}ifnum:)popdef({ifnum})},
    {errprint({{__ELSE__} DOES NOT MATCH {__THEN__}},
		__pick__({struct}),__nl__)})})

define({__ENDIF__},
  {ifelse(
     regexp(__pick__({struct}),
            {^@THEN:\(.*\):$},
	    {1{}pushdef({ifnum},{\1})}),
     1,
     {__pop__({struct})
      {ELSE}ifnum:
      {ENDIF}ifnum:
      popdef({ifnum})},
     regexp(__pick__({struct}),
            {^@ELSE:\(.*\):$},
            {1{}pushdef({ifnum},{\1})}),
     1,
     {__pop__({struct})dnl
      {ENDIF}ifnum:
      popdef({ifnum})},
     {errprint({{__ENDIF__} does not match {__THEN__} or {__ELSE__}},
		__pick__({struct}),__nl__)}
)})



dnl
dnl
dnl --- __REPEAT__ ... __UNTIL__ ---
dnl
define({REPEATNUM},0)
define({__EXIT__REPEAT__},{UNTIL})
define({__REPEAT__},
	{__push__({struct},{@REPEAT:}REPEATNUM:)
		{REPEAT}REPEATNUM:
		incrvar({REPEATNUM})
	})
define({__UNTIL__},
  {ifelse(
     regexp(__pick__({struct}),
            {@REPEAT:\(.*\):},
	    {1{}pushdef({repeatnum},{\1})}),
     1,
     {__pop__({struct})
	jn({$1}) {REPEAT}repeatnum
	{UNTIL}repeatnum:
      popdef({repeatnum})},
     {errprint({__UNTIL__ does not match __REPEAT__},
		__pick__({struct}),__nl__)}
)})
dnl
dnl --- __WHILE__ ... __DO__ ... __WEND__ ---
dnl
define({WHILENUM},0)
define({__EXIT__WHILE__},{WEND})
define({__EXIT__DO__},{WEND})
define({__WHILE__},
	{__push__({struct},{@WHILE}:WHILENUM:{$1})
		{WHILE}WHILENUM:
		incrvar({WHILENUM})
	})
define({__DO__},
  {ifelse(
    regexp(__pick__({struct}),{@WHILE:\(.*\):\(.*\)},
		{1{}pushdef({whilenum},{\1})pushdef({cc},{\2})}),
    1,
    {__pop__({struct})
     jn(cc) {WEND}whilenum
     __push__({struct},{@DO}:whilenum:)popdef({whilenum})popdef({cc})},
     {errprint({__DO__ does not match __WHILE__},
		__pick__({struct}),__nl__)})})
define({__WEND__},
  {ifelse(
     regexp(__pick__({struct}),
	    {@DO:\(.*\):},
	    {1{}pushdef({whilenum},{\1})}),
     1,
     {__pop__({struct})
      jmp {WHILE}whilenum
      {WEND}whilenum:
      popdef({whilenum})},
     {errprint({__WEND__ does not match __DO__},
		__pick__({struct}),__nl__)}
)})
dnl
dnl
dnl --- __EXIT__ ---
dnl
define({__EXIT__},
  {ifelse(
     regexp(__pick__({struct},eval($1-1)),
	    {@\(.*\):\(.*\):.*},
	    {1{}pushdef({struc},{\1})pushdef({num},{\2})}),
     1,
     {j$2 indir({__EXIT__}struc{__}){}num
      popdef({struc})popdef({num})},
     {errprint({cannot __EXIT__ what ???},__pick__({struct}),__nl__)})})
dnl
dnl
dnl ---------------------------- Diversions ----------------------------------
dnl
define({stringdiversion},5)

define({__textseg__},
    {indiversion(1,{
	.text
$*})})
define({__codeseg__},
    {indiversion(2,{
	.text
$*})})
define({__stringseg__},
    {indiversion(stringdiversion,{
	.text
$*})})
define({__dataseg__},
    {indiversion(3,{
	.data
$*})})
define({__udataseg__},
    {indiversion(4,{
	.bss
$*})})
define({__end__},
    {undivert})
dnl
dnl
dnl --------------------- Data definition ---------------------
dnl
define({quotestring},{"patsubst({$1},{\"},{\\"})"})
define({defb},
  {ifelse(
    {$#},0,,
    {$#},1,{defbone({$1})},
    {defbone({$1})defb(shift($@))})})
define({defbone},
  {ifelse(
     regexp({$1},{^\( 	\)*".*"},{1}),{1},
     {.ascii $1}__nl__,
     {.byte $1}__nl__)})

define({defstring},
{pushdef({labelprefix},{S})dnl
pushdef({strbeg},newlabel)dnl
pushdef({strend},newlabel)dnl
pushdef({strlen},newlabel)dnl
__stringseg__({
strbeg:
$3
defb($2)
$4
strend:
strlen = strend-strbeg
})dnl
$1
popdef({labelprefix})dnl
popdef({strbeg})dnl
popdef({strend})dnl
popdef({strlen})})dnl
dnl
define({stringaddr},{$1})
define({codeaddr},{$1})
dnl
define({lsa},
{defstring({mov {$1},#stringaddr(strbeg)},{shift($@)})})

ifelse({
dnl ---------------- Exportation de donnees -----------------------
Macro	Export	Identifier , Type , Name
  Local StringAddress, EName
  % ifnb <Name>
      EName equ Name
  % else
      EName equ Identifier
  % endif
  Segment HeaderStrings
    StringAddress:
    %	db	"Name" , 0
  EndS
  Segment HeaderBinary
	dd	StringAddress, ID, Type
  EndS
EndM
})
dnl
dnl
dnl ------------------------------- CONSOLE I/O ------------------------------
dnl
define({PUTC},
    {ifelse($#,0,,{mov al,{$1}})
     call Putc})
define({CGETC},
    {
     ifelse({$1},,,
	{ifelse({$2},,,{pushaX})
	 PUTS($1)
	 ifelse({$2},,,{popaX})})
	call cGetc})
define({PUTS},
    {
     ifelse({$*},{{CRLF}},{call PrCRLF},
	    {$*},{CRLF},{call PrCRLF},
	    {$*},{CR,LF},{call PrCRLF},
	    {$*},{13,10},{call PrCRLF},
	{ifelse({$1},,,{lsa(regext(si),$@,0)})
	 call Puts})})

dnl _Pr????_: msg1, [Addr: seg,] val, msg2
define({_PrByte_},
    {pushing({aX},{
     ifelse({$2},{al},,{__unseg__({mov al,},{$2})})
     ifelse({$1},,,
	{push regext(ax)
	 PUTS($1)
	 pop regext(ax)})
     call PutHexByte
     ifelse({$3},,,{PUTS($3)})})})
define({_PrAsciiZ_},
    {pushing({aX},{
     ifelse({$2},{regext(si)},,{__unseg__({mov regext(si),},{$2})})
     ifelse({$1},,,
	{push regext(si)
	PUTS($1)
	pop regext(si)})
     PUTS
     ifelse({$3},,,{PUTS($3)})})})
define({_PrWord_},
    {pushing({aX},{
     ifelse({$2},{ax},,{__unseg__({mov ax,},{$2})})
     ifelse({$1},,,
	{push regext(ax)
	 PUTS($1)
	 pop regext(ax)})
     call PutHexWord
     ifelse({$3},,,{PUTS($3)})})})
define({_PrAddr_},
    {pushing({aX,es},{
     pushm($2,$3)
     ifelse({$1},,,{PUTS($1)})
     popm(es,regext(di))
     call PutAddr
     ifelse({$4},,,{PUTS($4)})})})
define({_PrDword_},
    {pushad
     ifelse({$1},,
        {ifelse({$2},{eax},,{__unseg__({mov eax,},{$2})})},
	{__unseg__({push dword},{$2})
	 PUTS($1)
	 pop eax})
     call PutHexDword
     ifelse({$3},,,{PUTS($3)})
     popad
     nop})

dnl _Pr*Zone_: mes1,seg,addr,len,mes2
define({_PrZone_},
    {pushing({aX},{
     ifelse({$1},,
	{ifelse({$2},{es},,
		{ppmov(es,{$2})})
	 ifelse({$3},{regext(di)},,
		{__unseg__({mov regext(di),},{$3})})
	 ifelse({$4},{regext(cx)},,
		{__unseg__({mov regext(cx),},{$4})})},
	{pushm({$3},{$4})
         ifelse({$2},{es},,{pushm($2)})
	 PUTS($1)
         ifelse({$2},{es},,{pop es})
	 popm(regext(di),regext(cx))})
     call PutZone
     ifelse({$2},{es},,{pop es})
     ifelse({$5},,,{PUTS($5)})})})
define({_PrWZone_},
    {pushing({aX},{
     ifelse({$2},{es},,{push es})
     ifelse({$1},,
	{ifelse({$2},{es},,
		{ppmov(es,{$2})})
	ifelse({$3},{regext(di)},,
		{__unseg__({mov regext(di),},{$3})})
	ifelse({$4},{regext(cx)},,
		{__unseg__({mov regext(cx),},{$4})})},
	{pushm({$2},{$3},{$4})
	 PUTS($1)
	 popm(es,regext(di),regext(cx))})
     call PutWZone
     ifelse({$2},{es},,{pop es})
     ifelse({$5},,,{PUTS($5)})})})
define({_PrLZone_},
    {pushing({ad},{
     ifelse({$2},{es},,{push es})
     ifelse({$1},,
	{ifelse({$2},{es},,
		{ppmov(es,{$2})})
	ifelse({$3},{regext(di)},,
		{__unseg__({mov regext(di),},{$3})})
	ifelse({$4},{regext(cx)},,
		{__unseg__({mov regext(cx),},{$4})})},
	{pushm({$2},{$3},{$4})
	 PUTS($1)
	 popm(es,regext(di),regext(cx))})
     call PutLZone
     ifelse({$2},{es},,{pop es})
     ifelse({$5},,,{PUTS($5)})})})
dnl
dnl
dnl --------------------------- DEBUGGING AID -------------------------------
dnl
undefine({DEBUG})
define({__OUT__},
    {zzz({_OUT_($@)})})
define({zzz},{ifdef({DEBUG},{$1},{$2})})
define({zzzz},{ifdef({__DEBUG__},{$1},{$2})})
define({zzzzz},{})
define({__},{zzz({pushing(aX,{PUTS($@)})})})
define({z_z},
    {zzz({
     ifelse({$1},,,{pushing(aX,{PUTS($1)})})
     call DumpRegs
     ifelse({$2},,,{pushing(aX,{PUTS($2)})})})})
define({z__z},
    {zzz({
     ifelse({$1},,,{pushing(aX,{PUTS($1)})})
     call DumpERegs
     ifelse({$2},,,{pushing(aX,{PUTS($2)})})})})
define({zbyz},
    {zzz({
     _PrByte_($@)
     })})
define({zAsciiZz},
    {zzz({
     _PrAsciiZ_($@)
     })})
define({zwoz},
    {zzz({
     _PrWord_($@)
     })})
define({zdwoz},
    {zzz({
     _PrDword_($@)
     })})
define({zaddrz},
    {zzz({
     _PrAddr_($@)
     })})
define({zZonez},
    {zzz({
     _PrZone_($@)
     })})
define({zWZonez},
    {zzz({
     _PrWZone_($@)
     })})
define({zLZonez},
    {zzz({
     _PrLZone_($@)
     })})
dnl ---- Heavy debugging ----
define({STEP},
    {ifdef({__DEBUG__},
	{ppmov(gs,{$1})})})dnl   identifying position by value of gs in dumps

dnl STOP(seg,vidmembase,x,y,char,attr)
define({STOP},
    {zzzz({ifelse({$1},{ds},,{seg {$1}})
	 mov  word [{$2}+2*({$3})+2*80*({$4})],dnl
#{$5}+256*({$6})})})
define({STOP2},
    {zzzz({ifelse({$1},{ds},,{seg {$1}})
	 mov dword [{$2}+2*({$3})+2*80*({$4})],dnl
#{$5}+256*({$6}+256*({$7}+256*($8)))})})
define({DMSG},{
  defnz({__Debug_Message__},{$1})
  defnz({__Debug_X__},{$2})
  defnz({__Debug_Y__},{$3})
  defnz({__Debug_Color__},{$4})
  defnz({__Debug_seg__},{$5})
  defnz({__Debug_beg__},{$6})
})
define({_LETTER},
{STOP(__Debug_seg__,__Debug_beg__,
	varincr({__Debug_X__}),__Debug_Y__,
	'read_char({__Debug_Message__}),
	__Debug_Color__)})
define({_2LETTERS},
{STOP2(__Debug_seg__,__Debug_beg__,
	varadd({__Debug_X__},2),__Debug_Y__,
	'read_char({__Debug_Message__}),
	__Debug_Color__,
	'read_char({__Debug_Message__}),
	__Debug_Color__)
})
define({LETTER},
{ifelse($#,0,{_LETTER},
{ifelse(eval($1>1),1,{_2LETTERS LETTER(eval($1-2))},
eval($1),0,,{_LETTER})})})
define({DBG},
{pushdef({__Debug_Message__})
DMSG($@)LETTER(len({$1}))
popdef({__Debug_Message__})
})
define({SST},{ifdef({__DEBUG__},{pushing(aX,{CGETC({$@})})})})


dnl
dnl -------------- Support for install-time options dichotomy ----------------
dnl
dnl
defdef({OPTION_SIG},{"%%InStTiMeOpTiOn%%"})
define({IT_OPT},
{locals(OPT1,OPT2,END,{
{; $1}
	push dword #codeaddr(OPT1)
	ret
	.long codeaddr(OPT1),codeaddr(OPT2)
	defb(OPTION_SIG,"$1",0)
	OPT1:
	  ifelse(i386usemode,{},{add sp,2})
	  $2
	  ifelse({$3},{},,jmp END)
	OPT2:
	  ifelse(i386usemode,{},{add sp,2})
	  $3
	END:
})})
define({OPTDIE},{IT_OPT({$1},{___die___},{})})

dnl
dnl
dnl -------------------- Writing Libraries as Include files ------------------
dnl
dnl This is object managing at source code level. Reduces the number of
dnl object files (one source for any model), allows inlining, etc.
dnl
dnl To Do: use the STRUCSTK for this
dnl use markers to see if a particular procedure was already defined
dnl
define({LibProc},{
  pushdef({__RET__},{ret})
$1:
  indir(Lib_{$1},shift($@))
  popdef({__RET__})
})
define({LibFarProc},{
  pushdef({__RET__},{retf})
$1:
  indir(Lib_{$1},shift($@))
  popdef({__RET__})
})
define({LibInline},{
  pushdef({__RET__},{})
  indir(Lib_{$1},shift($@))
  popdef({__RET__})
})
define({LibMacro},{
dnl  pushdef({__RET__},{})
dnl  indir(Lib_{$1},shift($@))
dnl  popdef({__RET__})
})
dnl
dnl
dnl ------------------------ Procedure library ------------------------------
dnl
dnl --- detecting CPU type ---
define({Lib_TestCPU},{
  ;;;; Procedure initially taken from Robert L. Hummel's book
  ;;;; on 80x86 programming, then enhanced with the help of Cedric Ware.
  ;
  ; AH
  ; 01	8088 or 8086
  ; 02	80286
  ; 03	80386
  ; 04	486
  ; 05	Pentium
  ; 06	P6
  ;
  ; AL
  ; 00	No FPU
  ; 01	8087
  ; 02	80287
  ; 03	80387
  ; 04	486DX or 487SX
  ; 05	Pentium
  ; 06	P6
  ;
  ; Note: 0400 <=> 486SX w/o FPU.
  ;;;;;;
  ; destroys all general purpose registers, including FP registers
	mov	dx,0x0100	; default answer
	mov	ax,-1		; non zero
	push	ax		; was [NDP_STATUS],-1 ;
	mov	bp,sp		; save SP
  ;; on 8088/8086, bits 12 to 15 of pushed Flags value are set,
  ;; that's why we'll try to clear them.
	pushf
	pop	ax
	and	ah,0x0F		;(clear most significant bits)
	push	ax
	popf
	pushf
	pop	ax
	and	ah,0xF0		;(get them back)
	cmp	ah,0xF0
	jz	cpuid_2		;if all set, it's a 8086/8088
  ;; on the 80286, on the opposite, they are cleared
	inc	dh
	pushf
	pop	ax
	or	ah,0xF0		;(set most significant bits)
	push	ax
	popf
	pushf
	pop	ax
	and	ah,0xF0		;(get them back)
	jz	cpuid_2		;if cleared, it's a 80286
  ;; On the 80486, the EFLAGS registers has got an AC alignment bit
  ;; From late 486s on, the EFLAGS register has an ID bit (authorize CPUID)
	inc	dh
	cli
	and	sp,#~3		; align sp
	pushfd
	pop	eax
	mov	ebx,eax		; save eflags
	xor	eax,#FLAG_AC|FLAG_ID
	push	eax
	popfd
	pushfd
	pop	eax
	push	ebx
	popfd			; restore AC
	mov	sp,bp		; restore sp
	xor	eax,ebx		; look if AC or ID was modified
	sti
	jz	cpuid_2		; no: it's a 386
	inc	dh
	test	eax,#FLAG_ID	; ID modified ?
	;(!) I'm not sure this works like this:
	;perhaps instead I should test FLAG_ID...
	jz	cpuid_2		; no, it's an early 486
  ;; Now, we can use the CPUID instruction to determine the CPU type
  	clr(eax)		; sequence smaller than mov eax,1 !
	inc eax
	.byte	0x0F,0xA2	; CPUID
	and	ah,7		; CPU type in eax bits [11:8]
	mov	dh,ah		; stored in dh
  ;;;; Now, test for coprocessor:
cpuid_2:
	fninit				;reset status word
	fnstsw	[bp]
	cmp	byte [bp],0		;if non zero, no FPU
	jnz	cpuid_3
	fnstcw	[bp]			;try to write control word
	and	word [bp],0x103F
	cmp	word [bp],0x003F
	jnz	cpuid_3
  ;;;; The only case when the FPU doesn't answer is a 80386+80287
	mov	dl,dh			;initialize FPU type
	cmp	dh,#3			;no 386 => ok
	jnz	cpuid_3
  ;;; 387/287: the initialized NDP must manage infinity,
  ;;; but they're the same to the 287	FLD1
	fldz
	fdiv	st,st
	fld	st
	fchs
	fcompp
	fstsw	[bp]
	mov	ax,[bp]
	sahf
	jnz	cpuid_3			;different => 387
	dec	dl
cpuid_3:
	mov	ax,dx
	__RET__
})
dnl
dnl
dnl ------------------- Memory management in protected mode ------------------
dnl see file "mem386.doc" for dox...
dnl
dnl ------ A20 line control -----
dnl
dnl --- Constants to access line A20
define({KB_command_port},0x64)dnl  IOaddr to write to
define({KB_status_port}, 0x64)dnl  IOaddr to read from
define({KB_data_port},	 0x60)dnl  IOaddr to read from
define({IB_free},	 0x02)dnl  status bitmask: is kbd controller ready ?
define({KB_command_A20}, 0xD1)dnl  command bitmask to access A20 line.
define({set_A20_ON},     0xDF)dnl
define({set_A20_OFF},	 0xDD)dnl

dnl
dnl --- Macros to control line A20
dnl
define({Lib_KB_Ready},{
  local({wait_IB},{
dnl ;; Test if kbd port is available (needed before to send it commands)
dnl ;; - {$1} must be a label where to jump if line not available
dnl ;; - {$2} must be the number of tries before to jump to {$1}
dnl ;; ** destroys AX,CX
   ifelse({$2},,{mov regext(cx){,}100},
		{ifelse({$2},{regext(cx)},,{mov regext(cx),{$2}})})
  wait_IB:
   in al,#KB_status_port
   test al,#IB_free
   loopne wait_IB
   jcxz {$1}
   __RET__
})})

define({Lib_Set_A20},{
 ;; (de)activivates line A20,
 ;; - {$1} is ON or OFF, or void (then ah contains A20_ON or A20_OFF)
 ;; - (!) keyboard must be ready (use previous macro for that)
 ;; ** destroys AX
  ifelse({$1},,,{mov ah,{#set_A20_}_{$1}})
  mov al,#KB_command_A20
  out #KB_command_port,al
  ; Linus does call KB_Ready again !
  mov al,ah
  out #KB_command_port,al
  ; Linus does call KB_Ready again !
  __RET__
})

define({Lib_Test_A20},{
   local({Exit_},{
   ;; * tests if line A20 is activated, by seeing whether addresses are
   ;;  wrapped over 1MB.
   ;; * sets ax iff the line is activated
   pushm(ds,es,fd)
   cli			; disable interrupts
   clr(ax)
   mov es,ax		; es=$0000
   dec ax
   mov ds,ax		; ds=$FFFF
   mov ax,[-2]		;; verify [$10FFEE]=[$0FFEE]
   seg es
   cmp ax,[-18]
   stc
   jnz Exit_
   inc [-2]		;; verify [$10FFEE]=[$0FFEE] after modification
   seg es
   cmp ax,[-18]
   mov [-2],ax
   mov ax,-1
   jz Exit_
   inc ax
  Exit_:
   popm(ds,es,fd)	; enable interrupts again if needed
   __RET__
})})
dnl
dnl NMI enabling/disabling
dnl
dnl
define({Lib_Disable_NMI},{
	mov al,#0x80
	out #0x70,al
	in al,#0x71
	__RET__
})
define({Lib_Enable_NMI},{
	mov al,#0x00
	out #0x70,al
	in al,#0x71
	__RET__
})
dnl
dnl
dnl "...to accomplish a warm boot equivalent to Ctrl-Alt-Del, store 1234h
dnl in 0040h:0072h and jump to FFFFh:0000h.    For a cold boot equivalent
dnl to a reset, store 0000h at 0040h:0072h before jumping."
dnl
define({Lib_Reset_Computer},{
	mov al,#0xF0
	out #0x64,al
})
dnl
dnl
define({DefDescriptor},{
dnl  base,limit,_P_DPL_DT_Type,_G_D_0_AVL_0000
	.word	($2) & 0xFFFF
	.word	($1) & 0xFFFF
	.byte	(($1)>>16) & 0xFF
	.byte	($3)
	.byte	($4) + ( (($2)>>16)&0xF )
	.byte	($1)>>24
})
define({DefGate},{
dnl  sel,ofs,000compteur,_P_DPL_DT_Type
	.word	($2) & 0xFFFF
	.word	$1
	.byte	$3
	.byte	$4
	.word	($2) >> 16
})
define({Lib_SetDescriptor},{
;	DESCRIPT
   ;;; initialize a descriptor with
   ;;; - {$1} being the base address of the descriptor to initialize
   ;;; - ebx is base address of the segment
   ;;; - ecx is the limit field in byte or page according to granularity
   ;;; - al has got fields: P,DPL,DT,Type
   ;;; - ah has got fields: G,D,AVL
   ;;; * the routine saves all registers
   pushing({ebx,ecx},{
   mov [$1],cx
   mov [$1+2],bx
   shr ecx,#16
   shr ebx,#16
   or cl,ah
   mov ch,bh
   mov bh,al
   mov [$1+6],cx
   mov [$1+4],bx
   })
   __RET__
})
define({Lib_GetDescriptor},{
;	DESCRIPT
;;; This macro does the converse of preceding one:
;;; - {$1} contains base address of the descriptor
;;; * returns in ebx the base address of the segment
;;; * returns in ecx the limit field
;;; * returns in al fields: P,DPL,DT,Type
;;; * returns in ah fields: G,D,AVL
   mov cx,[$1+6]
   mov bx,[$1+4]
   mov al,bh
   mov bh,ch
   mov ah,cl
   and ah,#0xF0
   and cx,#0x0F
   shl ebx,#16
   shl ecx,#16
   mov bx,[$1+2]
   mov cx,[$1]
   __RET__
})
define({Std_Struc},{
dnl --- XMS Memory move ---
dnl
Struc({XMSMP},{
; Struc XMS_Move_Params		;; parameters for XMS func 0Bh
   _long_(LengthToMove)dnl
   _word_(SourceHandle)dnl
   _long_(SourceOffset)dnl
   _word_(DestHandle)dnl
   _long_(DestOffset)dnl
})

dnl --- Segment selectors ---
dnl
SEL_MASK	=	0xFFF8	; offset to descriptor entry in table
SEL_TI		=	0x0004	; bit cleared:GDT set:LDT
SEL_RPL		=	0x0003	; priviledge of segment making request


dnl --- Segment descriptors ---
dnl
DT_G		=	0x80 ; Granularity of limit 0=byte 1=page
DT_D		=	0x40 ; Default size using CS/SS 0=16bit 1=32bit
DT_AVL		=	0x10 ; AVaiLable to OS (unused by CPU)
DT_P		=	0x80 ; segment Present bit
DT_PL0		=	0x00 ; descriptor PriviLedge
DT_PL1		=	0x20
DT_PL2		=	0x40
DT_PL3		=	0x60
DT_DT		=	0x10 ; Descriptor Type, 1: segment, 0: special
; if DT_Segment (bit DT) is set:
DT_A		=	0x1 ; Accessed
DT_Data		=	0x0
DT_Writable	=	0x2 ; Writable
DT_E		=	0x4 ; Extensible downward
DT_Code		=	0x8
DT_R		=	0x2 ; Readable
DT_C		=	0x4 ; Conforming
; if DT_Segment -bit DT) is cleared:
DT_TSS16_A	=	0x1 ; available TSS 16
DT_LDT		=	0x2 ; LDT
DT_TSS16_B	=	0x3 ; busy TSS 16
DT_CallGate16	=	0x4
DT_TaskGate	=	0x5
DT_IntGate16	=	0x6
DT_TrapGate16	=	0x7
DT_TSS32_A	=	0x9 ; available TSS 32
DT_TSS32_B	=	0xB ; busy TSS 32
DT_CallGate32	=	0xC
DT_IntGate32	=	0xE
DT_TrapGate32	=	0xF
dnl a Trap gate requires CPL<=IOPL to be called; IF is unchanged
dnl an Interrupt gate clears IF; both Trap and Interrupt gates clear NT
dnl the counter is the number of stack arguments of a call gate.

dnl --- Page table entries ---
dnl
PG_P		=	0x01 ; Present
PG_RW		=	0x02 ; Read/Write
PG_US		=	0x04 ; User (PL3) access possible
PG_PWT		=	0x08 ; Page Write Through (486+)
PG_PCD		=	0x10 ; Page Cache Disable (486+)
PG_A		=	0x20 ; Accessed (486+)
PG_D		=	0x40 ; Dirty (undefined for page directory entries)
dnl bits 7,8 reserved
dnl bits 9-11 available to OS (typically, page locking, copy-on-write, etc)


dnl --- Structures ---
dnl
Struc({PUSHAD},{
  irp(reg,{EDI,ESI,EBP,ESP,EBX,EDX,ECX,EAX},
	{_long_(reg)})
})dnl
Struc({PUSHA},{
  irp(reg,{DI,SI,BP,SP,BX,DX,CX,AX},
	{_word_(reg)})
})dnl
Struc({V86INT},{
dnl That's what's in stack after an interrupt from VM86 mode
dnl into protected mode, after the possible error code has been poped
dnl and after a pushad instruction has been executed.
  irp(reg,
	{EDI,ESI,EBP,aESP,EBX,EDX,ECX,EAX,
	 EIP,CS,EFLAGS,ESP,SS,
	 ES,DS,FS,GS},
	{_long_(reg)})
})dnl
Struc({INTSTACK},{
dnl That's what's in stack after an interrupt in protected mode
dnl and *after the possible error code has been popped*
  irp(reg,
	{EIP,CS,EFLAGS,ESP,SS},
	{_long_(reg)})
})
Struc({TSS16},{
; SP_CPLx and LDT are not updated by task switching
irp(reg,{BackLinkSelector,
	 SP_CPL0,SS_CPL0,
	 SP_CPL1,SS_CPL1,
	 SP_CPL2,SS_CPL2,
	 IP,FLAGS,
	 AX,CX,DX,BX,
	 SP,BP,SI,DI,
	 ES,CS,SS,DS,
	 LDT},
	{_word_(reg)})
})
Struc({TSS32},{
; ESP_CPLx and LDT are not updated by task switching
irp(reg,{BackLinkSelector,
	 ESP_CPL0,SS_CPL0,
	 ESP_CPL1,SS_CPL1,
	 ESP_CPL2,SS_CPL2,
	 CR3,
	 EIP,EFLAGS,
	 EAX,ECX,EDX,EBX,
	 ESP,EBP,ESI,EDI,
	 ES,CS,SS,DS,FS,GS,
	 LDT},
	{_long_(reg)})
    _word_(TrapBit)
    _word_(IO_Map_Base)
})
dnl TSS32_CR3 is reserved by Intel but everyone I know seem to use it as
dnl a place to store the CR3 page directory register for the given task.
})



dnl
dnl
})dnl ------------------- end of as86 macros -------------------------
dnl
dnl
