dnl ----------------------=|=--- rmdebug.m4 ---=|=-----------------------------
dnl --=-- Debugging routines for the i386 in real mode --=---
dnl
dnl
dnl Lots of info taken from the sources of the Linux console driver.
dnl
Provide({rmdebug},{
dnl
dnl
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; RM Debugging ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

rmpart

define({rz__z},
    {zzz({
     ifelse({$1},,,
	{pushax
	 PUTS($1)
	 popax})
     call RM_DumpERegs
     ifelse({$2},,,
	{pushax
	 CGETC
	 popax})
     })})

Struc({RM_ERegs_D},{
  irp(reg,	{CS,FS,GS,SS},	{_word_(reg)})
  irp(reg,	{EIP,EDI,ESI,EBP,ESP,EBX,EDX,ECX,EAX},	{_long_(reg)})
  _word_(DS)	_word_(ES)	_long_(EFLAGS)
})

__stringseg__({

define({NamedDump},{
	.ascii "$1="
	.byte 0,$2,$3})

RM_ERegs_DumpLayout:
	irp(X,{
{EAX,8,3},     {EBX,8,3},     {ECX,8,3},     {EDX,8,5},       {EIP,8,6},
{ESI,8,3},     {EDI,8,3},     {EBP,8,3},     {ESP,8,5},       {EFLAGS,8,3},
{CS,4,2}, {DS,4,2}, {ES,4,2}, {FS,4,2}, {GS,4,2}, {SS,4,6},
{STK1,4,2},
{STK2,4,2}},
	{NamedDump(X)})


define({DumpDescr},{
	.byte ifelse({$2},{},{sizeof_$1/4},{$2})
	irp(reg,{EAX,EBX,ECX,EDX,EIP,ESI,EDI,EBP,ESP,EFLAGS,
		CS,DS,ES,FS,GS,SS},{.byte $1_{}reg
})	ifelse($#,1,{},$#,2,{},{.byte shift(shift($@))})})


RM_ERegs_DumpDescr:	DumpDescr({RM_ERegs_D},18,
				  sizeof_RM_ERegs_D+2,
				  sizeof_RM_ERegs_D+4)
})

__dataseg__({
RM_DumpLine:	.word 0
})



__codeseg__({

RM_DumpERegs:
	;STOP(fs,0xB8000,75,20,'E,0x07)
   ;;; Push data to dump:
	pushm(#0,ad,ds,es,fd)
	mov bp,sp
	push word [bp+2+sizeof_PUSHAD+8] ; IP
	add word [bp+2+PUSHAD_ESP],#10 ; SP
	pushm(cs,fs,gs,ss)
	;STOP(fs,0xB8000,76,20,'R,0x07)

   ;;; Use RM_MyDump
	sub bp,#10
	mov si,#rmaddr(RM_ERegs_DumpLayout)
	mov bx,#rmaddr(RM_ERegs_DumpDescr)
	;STOP(fs,0xB8000,77,20,'e,0x07)
	call RM_MyDump
	;STOP(fs,0xB8000,78,20,'g,0x07)
   ;;; Done
	add sp,12
	;STOP(fs,0xB8000,79,20,'s,0x07)
	popm(ad,ds,es,fd)
	ret


;;;;; Dump some commented data to screen
RM_MyDump:
;;; Dumps information with some layout
;;Input:
;; cs:si: a layout table
;; cs:bx: a dump parameter description table
;; ss:bp: parameter
;;Output:
;; all sgregisters but ss:sp,fs,gs are scrambled
   ;;; Setup Segments Registers
	push cs
	pop ds
	push #0xB800
	pop es
	cld
   ;;; Point to the current screen lines to output to
	mov ax,#80*2
	mul word [rmaddr(RM_DumpLine)]
	add word [rmaddr(RM_DumpLine)],#3
	mov di,ax
   ;;; Loop
	mov ah,#0x07		; video attribute
	movzx cx,byte [bx]	; number of values to show
	inc bx
Loopno0({pushing({cx},{
	;STOP(es,0,79,0,'0,0x0F)
     ;;; Show Texts
	call RM_DumpString
	;STOP(es,0,79,0,'T,0x0F)
     ;;; Show Hex Number
	movzx cx,byte [bx]	; offset of the value to show
	inc bx
	add bp,cx
	;STOP(es,0,79,0,'V,0x0C)
	mov edx,[bp]		; value to show
	;STOP(es,0,79,0,'V,0x0F)
	sub bp,cx
	pushing({cx},{
	  lodsb			; number of digits for the value
	  mov cl,al		; (high of ecx zeroed above)
	  call RM_DumpHex
	  ;STOP(es,0,79,0,'H,0x07)
	})
	;STOP(es,0,79,0,'H,0x0F)
     ;;; Show spaces
	__IF__(ncxz)
	  lodsb
	  mov cl,al
	  ;STOP(es,0,79,0,'I,0x0F)
	__THEN__
	  mov al,#0x20
	  rep
	  stosw
	  ;STOP(es,0,79,0,'S,0x0F)
	__ENDIF__
	;STOP(es,0,79,0,'L,0x0F)
	})})
	;STOP(es,0,79,0,'D,0x0F)
	ret


RM_DumpString0:
	stosw
RM_DumpString:
;; Dumps a 0-terminated string on screen, with attribute being ah.
	lodsb
	setf(al)
	jnz RM_DumpString0
	ret


RM_DumpHex:
;;Input:
;; edx: hex number to dump
;; cx: number of hex digits
;; es:di: video buffer position
;; ah: video attribute
;;Output:
;; every register saved
;; di: ends right after the last character
	add di,cx
	add di,cx
pushing({ax,cx,edx,di},{
	dec di
	dec di
	std
   Loopno0({
	mov al,dl
	and al,#0x0F
	add al,#0x30
	Ifcompare(ae,al,#0x3A,{add al,#0x41-0x3A})
	stosw
	shr edx,#4
})})
	cld
	ret

WaitGoPM:
zzzzz({
	__({"WaitGoPM"},CRLF)
	;call RM_Setup_RM_8259
	call RM_Unmask_IRQs
	SST({"Hit any key to go PM"},CRLF)	; won't work if IRQ masked !!!
	cli
	call RM_Mask_IRQs
	;call RM_Setup_PM_8259
	mov [rmaddr(RM_DumpLine)],#20
	rz__z
})
	ret

WaitGoRM:
   ;; Let's sleep a bit...
	;mov ecx,20
	;CallPMsub(sleep)
	STOP(fs,0xB8000,75,24,'S,0x0D)
	ret





;;;;;;;;;;;;;;;;;;;;;;;;;;;;; OLD DEBUGGING AID ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
__stringseg__({
  RegsMsg:	.ascii	"DI   SI   BP   SP   "
		.ascii	"BX   DX   CX   AX   "
		.ascii	"FLGS CS   DS   ES   "
		.ascii	"SS   IP   STK1 STK2"
		.byte	13,10,0
  ERegsMsg1:	.ascii	"EDI      ESI      EBP      ESP      "
		.ascii	"EBX      EDX      ECX      EAX      EFLAGS"
		.byte	13,10,0
  ERegsMsg2:	.ascii	"CS   DS   ES   SS   IP   STK1 STK2 STK3 "
		.ascii	"STK4 STK5 STK6 STK7 STK8 STK9 STKA STKB"
		.byte	13,10,0
})

RM_DumpERegs0:
	pushm(ad,fd,cs,ds,es,ss)
	pushm(cs,ss)
	popm(ds,es)
	mov si,#rmaddr(ERegsMsg1)
	PUTS
	mov di,sp
	mov cx,#9
	call PutLZone
	mov si,#rmaddr(ERegsMsg2)
	PUTS
	mov cx,16
	call PutWZone
	popm(ad,fd,es,ds,es,ss) ;no pop cs above 8086
 Return2:
	ret

DumpRegs:
	pushm(a,f,cs,ds,es,ss)
	pushm(cs,ss)
	popm(ds,es)
	mov si,#rmaddr(RegsMsg)
	PUTS
	mov di,sp
	mov cx,#16
	call PutWZone
	call PrCRLF
	popm(a,f,es,ds,es,ss)	;no pop cs above 8086
	ret

PutLZone_:
	call Space
PutLZone:
	seg es
	mov eax,[di]
	add di,#4
	call PutHexDword
	loop PutLZone_
	ret

PutWZone_:
	call Space
PutWZone:
	seg es
	mov ax,[di]
	inc di
	inc di
	call PutHexWord
	loop PutWZone_
	ret

PutZone_:
	call Space
PutZone:
	seg es
	mov al,[di]
	inc di
	call PutHexByte
	jcxz Return2
	call Space
	loop PutZone_
	ret

PutAddr:
;; Prints the contents of es:di
	push di
	mov ax,es
	call PutHexWord
	mov al,':
	call Putc
	pop di
	mov ax,di
	jmp PutHexWord

PutHexDword:
	rol eax,#16
	call PutHexWord
	rol eax,#16
;	jmp PutHexWord

PutHexWord:
; Prints the contents of AX in hexa.
; everything but F saved
	xchg al,ah
	call PutHexByte
	xchg al,ah
;	jmp PutHexByte

PutHexByte:
; Prints the contents of AL in hexa.
; saves AX.
	push cx
	rol al,#4
	call PutHexNybble
	rol al,#4
	pop cx
;	jmp PutHexNybble

PutHexNybble:
; Prints to BIOS console the hexa nybble in low AL
; saves AX, puts 7 into BX
	push ax
	and al,#0x0F
	add al,#'0
	cmp al,#10+'0
	jb do_putnyb
	add al,#'A-'0-10
 do_putnyb:
	PUTC
	pop ax
	ret

Space:
	mov al,#' 
	jmp Putc


Puts_:
	call Putc
Puts:
; Adapted from MicroSoft's own boot sector
; DS:SI=ASCIIZ string to print
; AX spoilt, SI points just after the string-ending zero, 7 put into BX.
	cld
	lodsb
	or al,al
	jnz Puts_
	ret

Beep:
; Echo a BEEP to the the Console
	mov al,#7
	;jmp cPutc

cPutc:
; Outputs a character to console
; spoils AX and DI, keeps si
	pushing({ad,f,es},{
	mov ah,#0xE	; function Teletype
	mov bx,#7	; attribute
	int #0x10	; Video BIOS call
	})
Return_:
	ret

cGetc:
	pushing(f,{
	clr(ah)
	int #0x16
	})
	ret

Putc=cPutc
Getc=cGetc

PrCRLF:
	PUTC(#13)
	mov al,#10
	jmp Putc

dnl
dnl
})})dnl --- debug.m4
dnl
